<template>
  <article class="view view--identity-public-password-reset">
    <FancyAlert v-if="reset" type="success">
      Your password has been successfully reset. You should now be able to log in using your new password.
    </FancyAlert>
    <div v-else>
      <FancyAlert type="info">
        <p>You should have received an email with instructions on how to reset your password.</p>
        <p>You can simply click the link in the email, or enter the validation code here.</p>
        <p>
          If you didn't receive the email, check your junk mail folder or go back to the
          <router-link :to="forgotPasswordRoute">forgot password page</router-link>
          to resend it.
        </p>
      </FancyAlert>
      <VForm
        name="account-password-reset-form"
        :fields="fields"
        :modelState="modelState"
        buttonText="Reset"
        buttonIconClass="bi bi-arrow-repeat"
        :busy="resetting"
        busyButtonText="Resetting..."
        :error="errorDescription"
        @input="onInput"
        @submit="onSubmit"
      />
    </div>
  </article>
</template>

<script>
import { ref, computed } from 'vue'
import { useRoute } from 'vue-router'
import { ValidationHelper, FancyAlert, VForm, useApi, useNotification } from '../../../core'
import UsersApi from '../../api/users-api.js'

export default {
  name: 'IdentityPublicPasswordResetView',
  components: {
    FancyAlert,
    VForm,
  },
  setup() {
    const route = useRoute()
    const api = useApi()
    const notify = useNotification()
    const usersApi = new UsersApi(api)

    const usernameOrEmail = computed(() => {
      return ValidationHelper.getString(route.query.usernameOrEmail, '')
    })

    const code = computed(() => {
      return ValidationHelper.getString(route.query.code, '')
    })

    const fields = ref([
      {
        type: 'text',
        name: 'usernameOrEmail',
        label: 'Username or email',
        validate: 'required',
        maxlength: 200,
        value: usernameOrEmail.value,
      },
      {
        type: 'text',
        name: 'code',
        label: 'Reset code',
        validate: 'required',
        maxlength: 200,
        value: code.value,
      },
      {
        type: 'password',
        name: 'newPassword',
        label: 'New password',
        validate: 'required',
        maxlength: 255,
        value: '',
      },
    ])

    const modelState = ref({})
    const errorDescription = ref('')
    const resetting = ref(false)
    const reset = ref(false)
    const forgotPasswordRoute = ref({ name: 'identity-public-forgot-password' })

    const onInput = () => {
      errorDescription.value = ''
    }

    const onSubmit = async (form) => {
      errorDescription.value = ''
      resetting.value = true
      reset.value = false

      try {
        await usersApi.resetPasswordAsync(form.usernameOrEmail, {
          resetCode: form.code,
          newPassword: form.newPassword,
        })
        reset.value = true
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else if (ex.response.data?.message) {
          errorDescription.value = ex.response.data.message
        } else {
          notify.error('There was a problem resetting your password.', ex)
        }
      } finally {
        resetting.value = false
      }
    }

    return {
      fields,
      modelState,
      errorDescription,
      resetting,
      reset,
      forgotPasswordRoute,
      onInput,
      onSubmit,
    }
  },
}
</script>
